package org.globus.transfer.reliable.service.test.connection;

import junit.framework.TestCase;
import org.globus.transfer.reliable.service.cache.ConnectionManager;
import org.globus.transfer.reliable.service.cache.ConnectionCacheConfiguration;
import org.globus.transfer.reliable.service.cache.Sweeper;
import org.globus.wsrf.impl.timer.TimerManagerImpl;
import commonj.timers.TimerManager;

public class SweeperTest extends TestCase {
    
    /**
     * Try to create a ConnectionManagerScheduler with various
     * invalid arguments.
     */
    public void testConstructor() {
        
        TimerManager timerManager = new TimerManagerImpl();
        ConnectionManager connManager = null;
        try {
            connManager = ConnectionManager.createNewInstance(
                new ConnectionCacheConfiguration(), timerManager);
        } catch(Exception e) {
            fail("creation of connection manager failed");
        }
        
        try {
            new Sweeper(null, connManager, 10);
            fail("null as argument of constructor of " +
                 "ConnectionManagerScheduler must fail");
        } catch (Exception e) {
            // ok, this should happen
        }
        
        try {
            new Sweeper(timerManager, null, 10);
            fail("null as argument of constructor of " +
                 "ConnectionManagerScheduler must fail");
        } catch (Exception e) {
            // ok, this should happen
        }
        
        try {
            new Sweeper(timerManager, connManager, -1);
            fail("negative sweeperInterval as argument of constructor of " +
                 "ConnectionManagerCleanupHook must fail");
        } catch (Exception e) {
            // ok, this should happen
        }
    }
}
